<nz-page-header>
  <nz-page-header-title>
    <nz-breadcrumb>
      <nz-breadcrumb-item><a routerLink="/">{{ 'Common.Homepage' | translate }}</a></nz-breadcrumb-item>
      <nz-breadcrumb-item>
        <a [routerLink]="['/army', army?.id]">{{ army?.name }}</a>
      </nz-breadcrumb-item>
      <nz-breadcrumb-item>{{ 'Military.Army.Squads' | translate }}</nz-breadcrumb-item>
    </nz-breadcrumb>
  </nz-page-header-title>
  <nz-page-header-extra *ngIf="isArmyLeader === true">
    <button nz-button nzType="default" (click)="name = undefined; isCreateFormVisible = !isCreateFormVisible"
      nzShape="round">
      {{ isCreateFormVisible ? "{{ 'Military.Army.cancelAdding' | translate }}" : "{{ 'Military.Army.addNewSquad' | translate }}" }}
    </button>
  </nz-page-header-extra>
</nz-page-header>

<nz-skeleton [nzLoading]="isLoading">
  <nz-collapse>
    <nz-collapse-panel [nzActive]="true" [nzHeader]="'Military.Army.createNewSquad' | translate" *ngIf="isCreateFormVisible">
      <div nz-row nzGutter="12" style="text-align: center">
        <div nz-col nzSpan="12">
          <input nz-input [placeholder]="'Military.Army.Name' | translate" [(ngModel)]="name" style="width: 100%" maxlength="20" />
        </div>
        <div nz-col nzSpan="6">
          {{ 'Economy.Currencies.Price' | translate }}: 2 <img src="{{ apiUrl }}/icons/currencies/gold.png" width="25"
            height="25" title="{{ 'Economy.Currencies.Gold' | translate }}" />
        </div>
        <div nz-col nzSpan="6">
          <button nz-button nzType="primary" (click)="createSquad()" [disabled]="!name" nzShape="round"
            style="background-color: green; color: white">
            {{ 'Common.Buttons.Create' | translate }}
          </button>
        </div>
      </div>
    </nz-collapse-panel>

    <nz-collapse-panel *ngFor="let squad of army?.squads" [nzHeader]="squad.name" [nzActive]="true" nzShowArrow="false"
      [nzDisabled]="true" [nzExtra]="squadExtra">
      <ng-template #squadExtra>
        <a [routerLink]="['citizen', squad.leader?.id]">
          <nz-tag *ngIf="squad.leader" [nzColor]="'green'">{{ 'Military.Army.Leader' | translate }}: {{ squad.leader.name }}</nz-tag>
        </a>

        <!-- Squad leader / army leader -->
        <button nz-button nzShape="round" class="button-basic" nz-tooltip [nzTooltipTitle]="'Military.Army.manageMembers' | translate" nzSize="small"
          (click)="manageSquad = squad" [nzLoading]="squad.isLoading"
          *ngIf="isArmyLeader === true || squad.isLeader === true">
          <i class="fas fa-users"></i>
        </button>

        <!-- Squad leader / army leader -->
        <!-- <button nz-button class="button-basic" nz-tooltip nzTooltipTitle="Edit name" (click)="setEditId(squad?.id)"
          nzSize="small" [nzLoading]="squad.isLoading" *ngIf="isArmyLeader === true || squad.isLeader === true">
          <i class="fas fa-tag"></i>
        </button> -->

        <!-- Army leader -->
        <button nz-button nzShape="round" class="button-basic" nz-tooltip [nzTooltipTitle]="'Military.Army.removeSquad' | translate" nzSize="small"
          [nzLoading]="squad.isLoading" nz-popconfirm [nzPopconfirmTitle]="'Military.Army.rySureSquad' | translate"
          (nzOnConfirm)="deleteSquad(squad.id)" *ngIf="isArmyLeader === true">
          <i class="fas fa-trash"></i>
        </button>
      </ng-template>

      <nz-spin [nzSpinning]="squad.isLoading">
        <div nz-row nzGutter="6" style="text-align: center">
          <div nz-col [nzSpan]="squad.isLeader === true ? 20 : 24">
            <nz-card *ngIf="!squad.editingOrder">
              <p *ngIf="squad.order" [innerHtml]="squad.order"></p>
              <p *ngIf="!squad.order">{{ 'Military.Army.squadHaveNoOrders' | translate }}</p>
            </nz-card>
            <textarea *ngIf="squad.editingOrder" rows="4" nz-input [(ngModel)]="squad.newOrder"
              [placeholder]="'Military.Army.writeNewOrder' | translate"></textarea>
          </div>
          <!-- Squad leader -->
          <div nz-col nzSpan="4" *ngIf="squad.isLeader === true">
            <nz-button-group *ngIf="!squad.editingOrder">
              <button nz-button nzShape="round" nz-tooltip [nzTooltipTitle]="'Military.Army.writeNewOrder' | translate" (click)="squad.editingOrder = true">
                <i class="fas fa-comment"></i>
              </button>
              <button nz-button nz-tooltip [nzTooltipTitle]="'Military.Army.cancelCurrentOrder' | translate" (click)="cancelOrder(squad)">
                <i class="fas fa-comment-slash"></i>
              </button>
            </nz-button-group>

            <nz-button-group *ngIf="squad.editingOrder">
              <button nz-button nzShape="round" nz-tooltip [nzTooltipTitle]="'Military.Army.confirmOrder' | translate" nzType="secondary" (click)="setOrder(squad)">
                <i nz-icon nzType="check" nzTheme="outline" style="color: green;"></i>
              </button>
              <button nz-button nzShape="round" nz-tooltip [nzTooltipTitle]="'Military.Army.Cancel' | translate" nzType="secondary"
                (click)="squad.newOrder = undefined; squad.editingOrder = false;">
                <i nz-icon nzType="delete" nzTheme="outline" style="color: red;"></i>
              </button>
            </nz-button-group>
          </div>
        </div>
      </nz-spin>
    </nz-collapse-panel>
  </nz-collapse>
</nz-skeleton>

<nz-modal *ngIf="manageSquad" [nzVisible]="true" [nzTitle]="manageSquadTitle"
  (nzOnCancel)="manageSquad = undefined; load()">
  <ng-template #manageSquadTitle> {{ 'Military.Squads.ManageSquadWithName' | translate }}: {{ manageSquad?.name }}
  </ng-template>
  <ng-container *nzModalContent>
    <nz-spin [nzSpinning]="manageSquad.isLoading">
      <h3>Squad leader: {{ manageSquad.leader?.name }}</h3>
      <nz-select style="width: 100%" nzSize="small" [(ngModel)]="manageSquad.leaderId"
        (ngModelChange)="setLeader(manageSquad)">
        <nz-option *ngFor="let member of unassignedMembers" [nzValue]="member.citizen.id"
          [nzLabel]="member.citizen.name">
        </nz-option>
      </nz-select>

      <nz-divider></nz-divider>

      <h3>Members</h3>
      <ul nz-list [nzDataSource]="manageSquad.members" nzBordered nzSize="small" nzNoResult="No members set"
        [nzLoading]="isLoading">
        <li nz-list-item *ngFor="let member of manageSquad.members" nzNoFlex>
          <ul nz-list-item-actions>
            <nz-list-item-action>
              <button nz-button nzShape="round" class="button-basic" nz-tooltip nzTooltipTitle="Remove member" style="color: red"
                (click)="removeMember(manageSquad, member.citizen.id)">
                <i class="fas fa-trash"></i>
              </button>
            </nz-list-item-action>
          </ul>
          <nz-avatar [nzIcon]="'user'" nzSize="32" [nzSrc]="member.citizen.avatar" nzShape="square"
            style="margin-right: 10px"></nz-avatar>
          <a [routerLink]="['/citizen', member.citizen.id]">{{ member.citizen.name }}</a>
        </li>
        <li nz-list-item nzNoFlex>
          <div nz-row nzJustify="center">
            <div nz-col nzSpan="18">
              <nz-select style="width: 100%" nzSize="small" [(ngModel)]="manageSquad.newMemberId"
                [nzLoading]="manageSquad.isLoading">
                <nz-option *ngFor="let member of unassignedMembers" [nzValue]="member.citizen.id"
                  [nzLabel]="member.citizen.name">
                </nz-option>
              </nz-select>
            </div>
            <div nz-col nzSpan="3">
              <button nz-button nzType="default" style="width: 100%" nzSize="small" (click)="setMember(manageSquad)"
                [nzLoading]="manageSquad.isLoading">
                Add
              </button>
            </div>
          </div>
        </li>
      </ul>
    </nz-spin>
  </ng-container>
</nz-modal>